SystemOrganization addCategory: #'Kinect-Core'!

Object subclass: #Point3D
	instanceVariableNames: 'x y z'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kinect-Core'!

!Point3D class methodsFor: 'instance creation' stamp: 'Richo 1/14/2011 13:50'!
x: x y: y z: z
	^ self basicNew setX: x setY: y setZ: z! !

!Point3D methodsFor: 'comparing' stamp: 'Richo 1/14/2011 14:08'!
= aPoint3D
	(aPoint3D isKindOf: self class)
		ifTrue: [^x = aPoint3D x and: [y = aPoint3D y and: [z = aPoint3D z]]]
		ifFalse: [^false]! !

!Point3D methodsFor: 'comparing' stamp: 'Richo 1/14/2011 14:09'!
hash
	"Hash is reimplemented because = is implemented."
	^ (x hash hashMultiply bitXor: y hash) hashMultiply bitXor: z hash! !

!Point3D methodsFor: 'printing' stamp: 'Richo 1/14/2011 13:53'!
printOn: aStream
x @ y printOn: aStream.
aStream nextPut: $@.
z negative ifTrue: [
		"Avoid ambiguous @- construct"
		aStream space].
z printOn: aStream.
! !

!Point3D methodsFor: 'private' stamp: 'Richo 1/14/2011 13:50'!
setX: aNumber setY: aNumber2 setZ: aNumber3 
	x := aNumber.
	y := aNumber2.
	z := aNumber3! !

!Point3D methodsFor: 'accessing' stamp: 'Richo 1/14/2011 13:53'!
x
^x! !

!Point3D methodsFor: 'accessing' stamp: 'Richo 1/14/2011 13:53'!
y
^y! !

!Point3D methodsFor: 'accessing' stamp: 'Richo 1/14/2011 13:53'!
z
^z! !

Object subclass: #Skeleton
	instanceVariableNames: 'head neck leftCollar leftShoulder leftElbow leftWrist leftHand leftFingertip rightCollar rightShoulder rightElbow rightWrist rightHand rightFingertip torso waist leftHip leftKnee leftAnkle leftFoot rightHip rightKnee rightAnkle rightFoot oscServer process'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kinect-Core'!

!Skeleton methodsFor: 'connection' stamp: 'Richo 1/14/2011 13:36'!
connect
	self isConnected ifTrue: [^self].
	oscServer := OSCServer listenOnPort: 7110.
	self startStepping.! !

!Skeleton methodsFor: 'connection' stamp: 'Richo 1/14/2011 13:35'!
disconnect
	self isConnected ifFalse: [^self].
	self stopStepping.
	oscServer terminate.
	oscServer := nil.! !

!Skeleton methodsFor: 'accessing' stamp: 'Richo 1/14/2011 14:13'!
head
	"Answer the value of head"

	^ head! !

!Skeleton methodsFor: 'initialize-release' stamp: 'Richo 1/14/2011 13:56'!
initialize
	super initialize.
	head := neck := leftCollar := leftShoulder := leftElbow := leftWrist := leftHand := leftFingertip := rightCollar := rightShoulder := rightElbow := rightWrist := rightHand := rightFingertip := torso := waist := leftHip := leftKnee := leftAnkle := leftFoot := rightHip := rightKnee := rightAnkle := rightFoot := 0@0@0! !

!Skeleton methodsFor: 'connection' stamp: 'Richo 1/14/2011 13:36'!
isConnected
	^ oscServer notNil! !

!Skeleton methodsFor: 'accessing' stamp: 'Richo 1/14/2011 14:13'!
leftAnkle
	"Answer the value of leftAnkle"

	^ leftAnkle! !

!Skeleton methodsFor: 'accessing' stamp: 'Richo 1/14/2011 14:13'!
leftCollar
	"Answer the value of leftCollar"

	^ leftCollar! !

!Skeleton methodsFor: 'accessing' stamp: 'Richo 1/14/2011 14:13'!
leftElbow
	"Answer the value of leftElbow"

	^ leftElbow! !

!Skeleton methodsFor: 'accessing' stamp: 'Richo 1/14/2011 14:13'!
leftFingertip
	"Answer the value of leftFingertip"

	^ leftFingertip! !

!Skeleton methodsFor: 'accessing' stamp: 'Richo 1/14/2011 14:13'!
leftFoot
	"Answer the value of leftFoot"

	^ leftFoot! !

!Skeleton methodsFor: 'accessing' stamp: 'Richo 1/14/2011 14:13'!
leftHand
	"Answer the value of leftHand"

	^ leftHand! !

!Skeleton methodsFor: 'accessing' stamp: 'Richo 1/14/2011 14:13'!
leftHip
	"Answer the value of leftHip"

	^ leftHip! !

!Skeleton methodsFor: 'accessing' stamp: 'Richo 1/14/2011 14:13'!
leftKnee
	"Answer the value of leftKnee"

	^ leftKnee! !

!Skeleton methodsFor: 'accessing' stamp: 'Richo 1/14/2011 14:13'!
leftShoulder
	"Answer the value of leftShoulder"

	^ leftShoulder! !

!Skeleton methodsFor: 'accessing' stamp: 'Richo 1/14/2011 14:13'!
leftWrist
	"Answer the value of leftWrist"

	^ leftWrist! !

!Skeleton methodsFor: 'accessing' stamp: 'Richo 1/14/2011 14:13'!
neck
	"Answer the value of neck"

	^ neck! !

!Skeleton methodsFor: 'parsing' stamp: 'Richo 1/14/2011 17:11'!
parse: msgArray 
	| position |
	msgArray size < 6
		ifTrue: [^ self].
	position := msgArray fourth @ msgArray fifth @ ((msgArray sixth / 3.5) min: 1).
	msgArray second caseOf: {
		['head'] -> [head := position].
		['neck'] -> [neck := position].
		['l_collar'] -> [leftCollar := position].
		['l_shoulder'] -> [leftShoulder := position].
		['l_elbow'] -> [leftElbow := position].
		['l_wrist'] -> [leftWrist := position].
		['l_hand'] -> [leftHand := position].
		['l_fingertip'] -> [leftFingertip := position].
		['r_collar'] -> [rightCollar := position].
		['r_shoulder'] -> [rightShoulder := position].
		['r_elbow'] -> [rightElbow := position].
		['r_wrist'] -> [rightWrist := position].
		['r_hand'] -> [rightHand := position].
		['r_fingertip'] -> [rightFingertip := position].
		['torso'] -> [torso := position].
		['waist'] -> [waist := position].
		['l_hip'] -> [leftHip := position].
		['l_knee'] -> [leftKnee := position].
		['l_ankle'] -> [leftAnkle := position].
		['l_foot'] -> [leftFoot := position].
		['r_hip'] -> [rightHip := position].
		['r_knee'] -> [rightKnee := position].
		['r_ankle'] -> [rightAnkle := position].
		['r_foot'] -> [rightFoot := position]}
		 otherwise: []! !

!Skeleton methodsFor: 'accessing' stamp: 'Richo 1/14/2011 14:13'!
rightAnkle
	"Answer the value of rightAnkle"

	^ rightAnkle! !

!Skeleton methodsFor: 'accessing' stamp: 'Richo 1/14/2011 14:13'!
rightCollar
	"Answer the value of rightCollar"

	^ rightCollar! !

!Skeleton methodsFor: 'accessing' stamp: 'Richo 1/14/2011 14:13'!
rightElbow
	"Answer the value of rightElbow"

	^ rightElbow! !

!Skeleton methodsFor: 'accessing' stamp: 'Richo 1/14/2011 14:13'!
rightFingertip
	"Answer the value of rightFingertip"

	^ rightFingertip! !

!Skeleton methodsFor: 'accessing' stamp: 'Richo 1/14/2011 14:13'!
rightFoot
	"Answer the value of rightFoot"

	^ rightFoot! !

!Skeleton methodsFor: 'accessing' stamp: 'Richo 1/14/2011 14:13'!
rightHand
	"Answer the value of rightHand"

	^ rightHand! !

!Skeleton methodsFor: 'accessing' stamp: 'Richo 1/14/2011 14:13'!
rightHip
	"Answer the value of rightHip"

	^ rightHip! !

!Skeleton methodsFor: 'accessing' stamp: 'Richo 1/14/2011 14:13'!
rightKnee
	"Answer the value of rightKnee"

	^ rightKnee! !

!Skeleton methodsFor: 'accessing' stamp: 'Richo 1/14/2011 14:13'!
rightShoulder
	"Answer the value of rightShoulder"

	^ rightShoulder! !

!Skeleton methodsFor: 'accessing' stamp: 'Richo 1/14/2011 14:13'!
rightWrist
	"Answer the value of rightWrist"

	^ rightWrist! !

!Skeleton methodsFor: 'stepping' stamp: 'Richo 1/14/2011 13:36'!
startStepping
	process
		ifNotNil: [process resume.
			^ self].
	process := [[self step] repeat] newProcess 
						name: self class asString;
						priority: Processor highIOPriority;
						resume! !

!Skeleton methodsFor: 'stepping' stamp: 'Richo 1/14/2011 15:32'!
step
	| msg |
	msg := oscServer nextMessage.
	self parse: msg."
	Transcript show: msg; cr."! !

!Skeleton methodsFor: 'stepping' stamp: 'Richo 1/14/2011 13:37'!
stopStepping
	process
		ifNotNil: [process terminate. process := nil]! !

!Skeleton methodsFor: 'accessing' stamp: 'Richo 1/14/2011 14:13'!
torso
	"Answer the value of torso"

	^ torso! !

!Skeleton methodsFor: 'accessing' stamp: 'Richo 1/14/2011 14:13'!
waist
	"Answer the value of waist"

	^ waist! !

!Point methodsFor: '*kinect-core' stamp: 'Richo 1/14/2011 13:48'!
@ aNumber
	^ Point3D x: x y: y z: aNumber! !

Morph subclass: #SkeletonMorph
	instanceVariableNames: 'head neck leftShoulder leftElbow leftHand rightShoulder rightElbow rightHand torso leftHip leftKnee leftFoot rightHip rightKnee rightFoot skeleton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kinect-Core'!

!SkeletonMorph class methodsFor: 'compiling' stamp: 'Richo 1/14/2011 15:35'!
compileUsefulMethods
"
self compileUsefulMethods.
"

self compile: (String streamContents: [:stream |
	stream nextPutAll: 'addSubmorphs'; cr; nextPutAll: '	"Autogenerated. See class side #compileUsefulMethods"'; cr.
SkeletonMorph instVarNames allButLast do: [:each |
stream nextPutAll: ('	self addMorph: (@joint := self newBodyPart setNameTo: ''@joint'').'
	copyReplaceAll: '@joint' with: each).
	] separatedBy: [stream cr]])
	classified: #initialize.

self compile: (String streamContents: [:stream |
	stream nextPutAll: 'step'; cr; nextPutAll: '	"Autogenerated. See class side #compileUsefulMethods"'; cr.
SkeletonMorph instVarNames allButLast do: [:each |
stream nextPutAll: ('	self position: @joint accordingTo: skeleton @joint.'
	copyReplaceAll: '@joint' with: each).
	] separatedBy: [stream cr].
stream cr.
])
	classified: #stepping! !

!SkeletonMorph methodsFor: 'initialize' stamp: 'Richo 1/14/2011 14:43'!
addSubmorphs
	"Autogenerated. See class side #compileUsefulMethods"
	self addMorph: (head := self newBodyPart setNameTo: 'head').
	self addMorph: (neck := self newBodyPart setNameTo: 'neck').
	self addMorph: (leftShoulder := self newBodyPart setNameTo: 'leftShoulder').
	self addMorph: (leftElbow := self newBodyPart setNameTo: 'leftElbow').
	self addMorph: (leftHand := self newBodyPart setNameTo: 'leftHand').
	self addMorph: (rightShoulder := self newBodyPart setNameTo: 'rightShoulder').
	self addMorph: (rightElbow := self newBodyPart setNameTo: 'rightElbow').
	self addMorph: (rightHand := self newBodyPart setNameTo: 'rightHand').
	self addMorph: (torso := self newBodyPart setNameTo: 'torso').
	self addMorph: (leftHip := self newBodyPart setNameTo: 'leftHip').
	self addMorph: (leftKnee := self newBodyPart setNameTo: 'leftKnee').
	self addMorph: (leftFoot := self newBodyPart setNameTo: 'leftFoot').
	self addMorph: (rightHip := self newBodyPart setNameTo: 'rightHip').
	self addMorph: (rightKnee := self newBodyPart setNameTo: 'rightKnee').
	self addMorph: (rightFoot := self newBodyPart setNameTo: 'rightFoot').! !

!SkeletonMorph methodsFor: 'initialize' stamp: 'Richo 1/14/2011 14:22'!
delete
	skeleton disconnect.
	super delete! !

!SkeletonMorph methodsFor: 'initialize' stamp: 'Richo 1/14/2011 15:57'!
initialize
	super initialize.
	self color: Color white;
		 borderColor: Color gray;
		 borderWidth: 1;
		 clipSubmorphs: true; 
		 extent: 640 @ 480.
	self addSubmorphs.
	skeleton := Skeleton new connect! !

!SkeletonMorph methodsFor: 'initialize' stamp: 'Richo 1/14/2011 14:21'!
newBodyPart
	^ EllipseMorph new color: Color blue muchLighter; borderWidth: 0; extent: 30@30! !

!SkeletonMorph methodsFor: 'stepping' stamp: 'Richo 1/14/2011 17:13'!
position: aMorph accordingTo: aSkeletonBodyPart 
	aMorph extent: (self height min: self width) / 5 * (1 - aSkeletonBodyPart z) * (1@1);
		 color: (Color blue alpha: (1 - aSkeletonBodyPart z));
		 center: self topLeft + (aSkeletonBodyPart x * self width @ (aSkeletonBodyPart y * self height))! !

!SkeletonMorph methodsFor: 'stepping' stamp: 'Richo 1/14/2011 14:51'!
step
	"Autogenerated. See class side #compileUsefulMethods"
	self position: head accordingTo: skeleton head.
	self position: neck accordingTo: skeleton neck.
	self position: leftShoulder accordingTo: skeleton leftShoulder.
	self position: leftElbow accordingTo: skeleton leftElbow.
	self position: leftHand accordingTo: skeleton leftHand.
	self position: rightShoulder accordingTo: skeleton rightShoulder.
	self position: rightElbow accordingTo: skeleton rightElbow.
	self position: rightHand accordingTo: skeleton rightHand.
	self position: torso accordingTo: skeleton torso.
	self position: leftHip accordingTo: skeleton leftHip.
	self position: leftKnee accordingTo: skeleton leftKnee.
	self position: leftFoot accordingTo: skeleton leftFoot.
	self position: rightHip accordingTo: skeleton rightHip.
	self position: rightKnee accordingTo: skeleton rightKnee.
	self position: rightFoot accordingTo: skeleton rightFoot.
	"Transcript show: 'head'; space; show: skeleton head z; cr.
	Transcript show: 'neck'; space; show: skeleton neck z; cr.
	Transcript show: 'leftShoulder'; space; show: skeleton leftShoulder z; cr.
	Transcript show: 'leftElbow'; space; show: skeleton leftElbow z; cr.
	Transcript show: 'leftHand'; space; show: skeleton leftHand z; cr.
	Transcript show: 'rightShoulder'; space; show: skeleton rightShoulder z; cr.
	Transcript show: 'rightElbow'; space; show: skeleton rightElbow z; cr.
	Transcript show: 'rightHand'; space; show: skeleton rightHand z; cr.
	Transcript show: 'torso'; space; show: skeleton torso z; cr.
	Transcript show: 'leftHip'; space; show: skeleton leftHip z; cr.
	Transcript show: 'leftKnee'; space; show: skeleton leftKnee z; cr.
	Transcript show: 'leftFoot'; space; show: skeleton leftFoot z; cr.
	Transcript show: 'rightHip'; space; show: skeleton rightHip z; cr.
	Transcript show: 'rightKnee'; space; show: skeleton rightKnee z; cr.
	Transcript show: 'rightFoot'; space; show: skeleton rightFoot z; cr."! !

!SkeletonMorph methodsFor: 'stepping' stamp: 'Richo 1/14/2011 14:22'!
stepTime
	^ 0! !
